      *****************************************************************
      * COPYRIGHT IBM CORP. 2012, 2013                                *
      *****************************************************************

      *****************************************************************
      *****************************************************************
      **  Shared REXX Variable Request Block mapping.                **
      *****************************************************************
      *****************************************************************

      *****************************************************************
      *   SHARED VARIABLE REQUEST BLOCK                               *
      *****************************************************************
       01  SHVBLOCK.
      *       Chain pointer to next SHVBLOCK
           02  SHVNEXT             USAGE POINTER.
      *       Used during "FETCH NEXT"
      *        Contains length of buffer
      *        pointed to by SHVNAMA
           02  SHVUSER             PIC S9(9) BINARY.
           02  SHVCODES.
      *       Function code - indicates type
               03 SHVCODE          PIC A.
      *       Return codes
               03 SHVRET           PIC X.
      *       Reserved (should be 0)
           02                      PIC X(2).
      *       Length of fetch value buffer
           02  SHVBUFL             PIC S9(9) BINARY.
      *
      *       Address of variable name
           02  SHVNAMA             USAGE POINTER.
      *       Length of variable name
      *        (Set on fetch)
           02  SHVNAML             PIC S9(9) BINARY .
      *       Address of value buffer
           02  SHVVALA             USAGE POINTER.
      *       Length of value buffer
           02  SHVVALL             PIC S9(9) BINARY .
      *
      *    Length of SHVBLOCK
       77   SHVBLEN                PIC 9(9) BINARY VALUE IS 32 .
      *
      *****************************************************************
      *   SHARED VARIABLE REQUEST BLOCK - function codes              *
      *****************************************************************
      *    Set variable from given value
       77   SHVSTORE               PIC A VALUE IS 'S'.
      *    Copy value of variable to Buffer
       77   SHVFETCH               PIC A VALUE IS 'F'.
      *    Drop variable
       77   SHVDROPV               PIC A VALUE IS 'D'.
      *    Symbolic name Set variable
       77   SHVSYSET               PIC A VALUE IS 's'.
      *    Symbolic name Fetch variable
       77   SHVSYFET               PIC A VALUE IS 'f'.
      *    Symbolic name DROP variable
       77   SHVSYDRO               PIC A VALUE IS 'd'.
      *    Fetch next variable
       77   SHVNEXTV               PIC A VALUE IS 'N'.
      *    Fetch private information
       77   SHVPRIV                PIC A VALUE IS 'P'.

      *****************************************************************
      *   SHARED VARIABLE REQUEST BLOCK - return codes (SHVRET)       *
      *****************************************************************
      *   Execution was OK
       77   SHVCLEAN               PIC X VALUE IS X'00'.
      * Variable did not exist
       77   SHVNEWV                PIC X VALUE IS X'01'.
      * Last variable transferred ("N")
       77   SHVLVAR                PIC X VALUE IS X'02'.
      * Truncation occurred for "Fetch"
       77   SHVTRUNC               PIC X VALUE IS X'04'.
      * Invalid variable name
       77   SHVBADN                PIC X VALUE IS X'08'.
      * Invalid value specified
       77   SHVBADV                PIC X VALUE IS X'10'.
      * Invalid function code (SHVCODE)
       77   SHVBADF                PIC X VALUE IS X'80'.
