***********************************************************************
* COPYRIGHT IBM CORP. 2011, 2013                                      *
***********************************************************************
*
         GBLA     &DEBUG
&DEBUG   SETA (',&SYSPARM,' INDEX ',DEBUG,')
*
ASMPIPC  CSECT
ASMPIPC  AMODE 31
ASMPIPC  RMODE ANY
         STM   R14,R12,12(R13)    Save caller's registers
         LR    R12,R15            Get base address
         USING ASMPIPC,R12        Identify base register
         ST    R13,SAVE+4         Back-chain the save area
         LA    R15,SAVE           Get addr of this routine's save area
         ST    R15,8(R13)         Forward-chain in caller's save area
         LR    R13,R15            R13 -> save area of this routine
*
         LR    R3,R1               Save EFPL
         USING EFPL,R3
*
         AIF (&DEBUG EQ 0).NDBG001
         WTO   'ASMPIPC : Entering ASMPIPC...',ROUTCDE=11
.NDBG001 ANOP
*
* Load LE CEEPIPI service routine into main storage.
*
         L     R1,efplarg
         USING argtable_entry,R1
*  Arg 1
         LHI   R3,0               1st arg index
**BLL    L     R2,argtable_argstring_ptr(0*argtelen) 1st arg ptr
         L     R2,argtable_argstring_ptr(R3)  1st arg ptr
         L     R2,0(R2)           1st arg (we know len is 4)
         ST    R2,PPRTNPTR        Save the addr of CEEPIPI routine
*  Arg 2
         AHI   R3,argtelen        2nd arg index
**BLL    L     R2,argtable_argstring_ptr(1*argtelen) 2nd arg ptr
         L     R2,argtable_argstring_ptr(R3)  2nd arg ptr
         L     R2,0(R2)           2nd arg (we know len is 4)
         ST    R2,TOKEN           Save the TOKEN
*
         AHI   R3,argtelen         3rd arg index -- for callee
         AR    R1,R3                . we'll
         ST    R1,PARMLIS@          ...pass
         LA    R1,PARMLIS@         .... only
         ST    R1,PARMPTR           ..... strings
         DROP  R1
*
* Call the subroutine, which was loaded by LE
*
CSUB     EQU   *
         AIF (&DEBUG EQ 0).NDBG002
         WTO   'ASMPIPC : about call to (CALL_SUB)',ROUTCDE=11
.NDBG002 ANOP
         L     R15,PPRTNPTR       Get address of CEEPIPI routine
         CALL  (15),(CALLSUB,PTBINDEX,TOKEN,PARMPTR,                   X
               SUBRETC,SUBRSNC,SUBFBC)   Invoke CEEPIPI routine
*                                 Check return code:
         LTR   R2,R15               Is R15 = zero?
         BZ    DONE                 Yes (success).. go to next section
*                                   No (failure).. issue message & quit
         AIF (&DEBUG EQ 0).NDBG003
         WTO   'ASMPIPC : call to (CALL_SUB) failed',ROUTCDE=11
.NDBG003 ANOP
         ABEND (R2),DUMP          Abend with bad RC and dump memory
*
* Standard exit code.
*
DONE     EQU   *
         AIF (&DEBUG EQ 0).NDBG004
         WTO   'ASMPIPC : back from call to (CALL_SUB)',ROUTCDE=11
         WTO   'ASMPIPC : Leaving ASMPIPC...',ROUTCDE=11
.NDBG004 ANOP
         LA    R15,0                Passed return code for system
         L     R13,SAVE+4           Get address of caller's save area
         L     R14,12(R13)          Reload caller's register 14
         LM    R0,R12,20(R13)       Reload caller's registers 0-12
         BR    R14                  Branch back to caller
*
* =====================================================================
* CONSTANTS and SAVE AREA.
* =====================================================================
SAVE     DC    18F'0'
PPRTNPTR DS    A                  Save the address of CEEPIPI routine
PARMLIS@ DS    A                   @PARMLIST
*
* Parameters passed to a (INIT_SUB) call.
*
INITSUB  DC    F'3'               Function code to initialize for subr
@CEXPTBL DC    A(PPTBL)           Address of Preinitialization Table
@SRVRTNS DC    A(0)               Addr of service-rtns vector, 0 = none
RUNTMOPT DC    CL255' '           Fixed length string of runtime optns
TOKEN    DS    F                  Unique value returned (output)
*
* Parameters passed to a (CALL_SUB) call.
*
CALLSUB  DC    F'4'               Function code to call subroutine
PTBINDEX DC    F'0'               The row number of Preinitialization 
*                                 Table entry
PARMPTR  DC    A(0)               Pointer to @PARMLIST or zero if none
SUBRETC  DS    F                  Subroutine return code (output)
SUBRSNC  DS    F                  Subroutine reason code (output)
SUBFBC   DS    3F                 Subroutine feedback token (output)
*

* Parameters passed to a (TERM) call.
*
TERM     DC    F'5'               Function code to terminate
ENV_RC   DS    F                  Environment return code (output)
*
* =====================================================================
* Preinitialization Table.
* =====================================================================
PPTBL    CEEXPIT  ,               Preinitialization Table with index
         CEEXPITY HLLPIPI,0       0 = dynamically loaded routine
*
         CEEXPITS ,               End of PreInit table
*
*
         LTORG
**
efpl1    IRXEFPL
argtb    IRXARGTB
argtelen EQU    ARGTABLE_NEXT-ARGTABLE_ARGSTRING_PTR
*
         YREGS
*
         END   ASMPIPC
